"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ReportedVariantCancer(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "alleleOrigins",
        "alternate",
        "chromosome",
        "position",
        "reference",
        "reportEvents",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "reportEvents": reports_4_2_0.ReportEventCancer,
            "variantCalls": reports_4_2_0.VariantCall,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "alleleOrigins": reports_4_2_0.AlleleOrigin,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "org.gel.models.report.avro.AlleleOrigin": reports_4_2_0.AlleleOrigin,
            "org.gel.models.report.avro.ReportEventCancer": reports_4_2_0.ReportEventCancer,
            "org.gel.models.report.avro.VariantCall": reports_4_2_0.VariantCall,
            "org.gel.models.report.avro.ReportedVariantCancer": reports_4_2_0.ReportedVariantCancer,
        }

    __slots__ = [
        "alleleOrigins",
        "alternate",
        "chromosome",
        "position",
        "reference",
        "reportEvents",
        "additionalNumericVariantAnnotations",
        "additionalTextualVariantAnnotations",
        "cdnaChange",
        "clinVarIds",
        "comments",
        "commonAf",
        "cosmicIds",
        "dbSnpId",
        "ihp",
        "proteinChange",
        "variantCalls",
    ]

    def __init__(
        self,
        alleleOrigins,
        alternate,
        chromosome,
        position,
        reference,
        reportEvents,
        additionalNumericVariantAnnotations=None,
        additionalTextualVariantAnnotations=None,
        cdnaChange=None,
        clinVarIds=None,
        comments=None,
        commonAf=None,
        cosmicIds=None,
        dbSnpId=None,
        ihp=None,
        proteinChange=None,
        variantCalls=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_2_0.ReportedVariantCancer model.

        :param alleleOrigins:
            Describe whether this is a somatic or Germline variant
        :type alleleOrigins: list[AlleleOrigin]
        :param alternate:
            alternate: Alternate Allele sequence, the same provided in vcf
        :type alternate: str
        :param chromosome:
            chromosome, named as: 1-22,X,Y,MT(other contigs name)
        :type chromosome: str
        :param position:
            position: Position 1-based
        :type position: int
        :param reference:
            reference: Reference Allele sequence, the same provided in vcf
        :type reference: str
        :param reportEvents:
            The report events
        :type reportEvents: list[ReportEventCancer]
        :param additionalNumericVariantAnnotations:
            For Example (Allele Frequency, sift, polyphen, mutationTaster, CADD.
            ..)
        :type additionalNumericVariantAnnotations: None | dict[str, float]
        :param additionalTextualVariantAnnotations:
            For example HGMD ID)
        :type additionalTextualVariantAnnotations: None | dict[str, str]
        :param cdnaChange:
            cDNA change, HGVS nomenclature (e.g.)
        :type cdnaChange: None | str
        :param clinVarIds:
            variant ID in ClinVar
        :type clinVarIds: None | list[str]
        :param comments:
            Comments
        :type comments: None | list[str]
        :param commonAf:
            AF in germline DBs
        :type commonAf: None | int
        :param cosmicIds:
            variant ID in Cosmic
        :type cosmicIds: None | list[str]
        :param dbSnpId:
            variant ID in dbSNP
        :type dbSnpId: None | str
        :param ihp:
            Largest reference interrupted homopolymer length intersecting with the
            indel
        :type ihp: None | int
        :param proteinChange:
            protein change, HGVS nomenclature (e.g.)
        :type proteinChange: None | str
        :param variantCalls:
            List of variant calls
        :type variantCalls: None | list[VariantCall]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.2.0"
